package gui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/********************************************************/
/**
 * Used to create a button which listens for its own click event.
 */
public abstract class RunButton
        extends JButton implements ActionListener {

	/********************************************************/
	/**
	 * Create a RunButton with the specified caption.
	 */
    public RunButton(String caption) {
        super(caption);
        addActionListener(this);
    }

	/********************************************************/
	/**
	 * Create a RunButton with the specified icon.
	 */
    public RunButton(Icon icon) {
        super(icon);
        addActionListener(this);
    }

	/********************************************************/
	/**
	 * Implements the ActionListener interface to allow the
	 * RunButton to be aware of its own click event.
	 */
    public abstract void actionPerformed(ActionEvent e);
}
