package Phasor;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import gui.RunButton;

public class ControlPanel extends JFrame {
		 boolean firstStep;
		 private JTextField jtOm1, jtOm2, jtAm1, jtAm2, jtPh1, jtPh2;
		 Geometry geom;
		 PhasorView phas;
		 SineView sinv;
		 static Timer ticker;
		 static TickListener tocker;
		 static int milliseconds = 100; //Display timer
		 public ControlPanel(int locx, int locy, int sizx, int sizy,
		 					 int tick, Geometry gm, PhasorView ph, SineView sn,
		 					 double om1, double om2, double am1,
		 					 double am2, double ph1, double ph2
		 					 )
		 {
		 		 Container c = getContentPane();
		 		 geom = gm;
		 		 phas = ph;
		 		 sinv = sn;
		 		 c.setLayout(new FlowLayout());
		 		 geom.setGeometry (om1, om2, am1, am2, ph1, ph2);
		 		 jtOm1 = new JTextField(10); jtOm1.setText(String.valueOf(om1));
		 		 jtOm2 = new JTextField(10); jtOm2.setText(String.valueOf(om2));
		 		 jtAm1 = new JTextField(10); jtAm1.setText(String.valueOf(am1));
		 		 jtAm2 = new JTextField(10); jtAm2.setText(String.valueOf(am2));
		 		 jtPh1 = new JTextField(10); jtPh1.setText(String.valueOf(ph1));
		 		 jtPh2 = new JTextField(10); jtPh2.setText(String.valueOf(ph2));
		 		 c.add(new JLabel("Omega1:    "));	c.add(jtOm1);
		 		 c.add(new JLabel("Omega2:    "));	c.add(jtOm2);
		 		 c.add(new JLabel("Amplitude1:"));	c.add(jtAm1);
		 		 c.add(new JLabel("Amplitude2:"));	c.add(jtAm2);
		 		 c.add(new JLabel("Phi1:      "));	c.add(jtPh1);
		 		 c.add(new JLabel("Phi2:      "));	c.add(jtPh2);

		 		 c.add(new RunButton("Set/Reset") 
		 		 {
            		public void run() 
            		{
            			String tmp = jtOm1.getText();
		 		 		double oM1 = Double.parseDouble(tmp);
		 		 		tmp = jtOm2.getText();
		 		 		double oM2 = Double.parseDouble(tmp);
		 		 		tmp = jtAm1.getText();
		 		 		double aM1 = Double.parseDouble(tmp);
		 		 		tmp = jtAm2.getText();
		 		 		double aM2 = Double.parseDouble(tmp);
		 		 		tmp = jtPh1.getText();
		 		 		double pH1 = Double.parseDouble(tmp);
		 		 		tmp = jtPh2.getText();
		 		 		double pH2 = Double.parseDouble(tmp);
		 		 
		 		 		geom.setGeometry (oM1, oM2, aM1, aM2, pH1, pH2);
		 		 		geom.upDateGeometry();
		 		 		phas.setClean(true);
		 		 		sinv.setClean(true);	
            		}
            	 });

		 		 tocker = new TickListener();		 	
		 		 setDisplayTick(tick);
		 		 
		 		 /*		 		 
		 		 */

		 		 setLocation(locx,locy);
		 		 setSize(sizx,sizy);
		 		 show();
		 }
		 
		 public void startTicker()
		 {
		 		ticker.start();
		 }
		 private class TickListener implements ActionListener {
		 		 public void actionPerformed(ActionEvent e){
		 		 		 //System.out.print (" Tick ");
		 		 		 geom.upDateGeometry();
		 		 		 phas.repaint();
		 		 		 sinv.repaint();
		 		 }
		 }
		 static void setDisplayTick( int tick ){
		 		 milliseconds = tick;
		 		 ticker =  new Timer(milliseconds, tocker);
		 }

}

